ORG 0
BITS 32
; ------------------------------------------------------------- ;
PATH_SIZE                      equ  4096
PARAMS_SIZE                    equ  4096
STACK_SIZE                     equ  4096
END                            equ  IMAGE_BASE - (PATH_SIZE + PARAMS_SIZE + STACK_SIZE)
; ------------------------------------------------------------- ;
IMAGE_BASE                     equ  400000H
MAGIC_OFFSET                   equ  16 ; Hack For Delphi7 {$APPTYPE GUI}
; MAGIC_OFFSET                   equ  24 ; Hack For Delphi7 {$APPTYPE CONSOLE}
; ------------------------------------------------------------- ;
struc IMAGE_DOS_HEADER
  .e_magic                     resw 1
  .e_cblp                      resw 1
  .e_cp                        resw 1
  .e_crlc                      resw 1
  .e_cparhdr                   resw 1
  .e_minalloc                  resw 1
  .e_maxalloc                  resw 1
  .e_ss                        resw 1
  .e_sp                        resw 1
  .e_csum                      resw 1
  .e_ip                        resw 1
  .e_cs                        resw 1
  .e_lfarlc                    resw 1
  .e_ovno                      resw 1
  .e_res                       resw 4
  .e_oemid                     resw 1
  .e_oeminfo                   resw 1
  .e_res2                      resw 10
  .e_lfanew                    resd 1
endstruc
; ------------------------------------------------------------- ;
struc IMAGE_OPTIONAL_HEADER
  .Magic                       resw 1
  .MajorLinkerVersion          resb 1
  .MinorLinkerVersion          resb 1
  .SizeOfCode                  resd 1
  .SizeOfInitializedData       resd 1
  .SizeOfUninitializedData     resd 1
  .AddressOfEntryPoint         resd 1
  .BaseOfCode                  resd 1
  .BaseOfData                  resd 1
  .ImageBase                   resd 1
  .SectionAlignment            resd 1
  .FileAlignment               resd 1
  .MajorOperatingSystemVersion resw 1
  .MinorOperatingSystemVersion resw 1
  .MajorImageVersion           resw 1
  .MinorImageVersion           resw 1
  .MajorSubsystemVersion       resw 1
  .MinorSubsystemVersion       resw 1
  .Win32VersionValue           resd 1
  .SizeOfImage                 resd 1
  .SizeOfHeaders               resd 1
  .CheckSum                    resd 1
  .Subsystem                   resw 1
  .DllCharacteristics          resw 1
  .SizeOfStackReserve          resd 1
  .SizeOfStackCommit           resd 1
  .SizeOfHeapReserve           resd 1
  .SizeOfHeapCommit            resd 1
  .LoaderFlags                 resd 1
  .NumberOfRvaAndSizes         resd 1
  .DataDirectory               resb 0
endstruc
; ------------------------------------------------------------- ;
struc IMAGE_FILE_HEADER
  .Machine                     resw 1
  .NumberOfSections            resw 1
  .TimeDateStamp               resd 1
  .PointerToSymbolTable        resd 1
  .NumberOfSymbols             resd 1
  .SizeOfOptionalHeader        resw 1
  .Characteristics             resw 1
endstruc
; ------------------------------------------------------------- ;
struc IMAGE_SECTION_HEADER
    .Name                      resb 8
    .VirtualSize               resd 1
    .VirtualAddress            resd 1
    .SizeOfRawData             resd 1
    .PointerToRawData          resd 1
    .PointerToRelocations      resd 1
    .PointerToLinenumbers      resd 1
    .NumberOfRelocations       resw 1
    .NumberOfLinenumbers       resw 1
    .Characteristics           resd 1
endstruc
; ------------------------------------------------------------- ;
struc IMAGE_NT_HEADERS
    .Signature                 resd 1
    .FileHeader                resb IMAGE_FILE_HEADER_size
    .OptionalHeader            resb IMAGE_OPTIONAL_HEADER_size
endstruc
; ------------------------------------------------------------- ;
MENUET01                       db   'MENUET01'
version                        dd   1
program.start                  dd   START
program.end                    dd   END
program.memory                 dd   END + PATH_SIZE + PARAMS_SIZE + STACK_SIZE
program.stack                  dd   END + PATH_SIZE + PARAMS_SIZE + STACK_SIZE
program.params                 dd   END + PATH_SIZE
program.path                   dd   END
; ------------------------------------------------------------- ;
sz_pe_load                     db   "PELoad",0
; ------------------------------------------------------------- ;
sz_con_init                    db   "con_init",0
sz_con_write_asciiz            db   "con_write_asciiz",0
sz_con_exit                    db   "con_exit",0
sz_console                     db   "/sys/lib/console.obj",0
; ------------------------------------------------------------- ;
err_file_path                  db   "No input file path",0
err_read_file                  db   "Read file error",0
err_mz_not_found               db   "No DOS signature found",0
err_pe_not_found               db   "No PE signature found",0
; ------------------------------------------------------------- ;
sz_empty                       db   "",0
; ------------------------------------------------------------- ;
LoadLibrary:
        mov    eax, 68
        mov    ebx, 19
        mov    ecx, [esp + 4]
        int    64
        ret    4
; ------------------------------------------------------------- ;
GetProcAddress:
        mov    edx, [esp + 8]
        xor    eax, eax
        test   edx, edx
        jz     .end
.next:
        xor    eax, eax
        cmp    [edx], dword 0
        jz     .end
        mov    esi, [edx]
        mov    edi, [esp + 4]
.next_:
        lodsb
        scasb
        jne    .fail
        or     al, al
        jnz    .next_
        jmp    .ok
.fail:
        add    edx, 8
        jmp    .next
.ok:
        mov    eax, [edx + 4]
.end:
        ret    8
; ------------------------------------------------------------- ;
ReallocAppMemory:
        mov    eax, 64
        mov    ebx, 1
        mov    ecx, [esp + 4]
        int    64
        ret    4
; ------------------------------------------------------------- ;
SetCurrentDirectory:
        mov    eax, 30
        mov    ebx, 1
        mov    ecx, [esp + 4]
        int    64
        ret    4
; ------------------------------------------------------------- ;
START:
; ------------------------------------------------------------- ;
; Find Params And File Path
        mov    eax, [program.params]
        cmp    [eax], byte '"'
        jne    .no_quote
        inc    eax
        mov    edi, eax
.find_quote_or_zero:
        cmp    [edi], byte 0
        je     .found
        cmp    [edi], byte '"'
        je     .found
        inc    edi
        jmp    .find_quote_or_zero
.no_quote:
        mov    edi, eax
.find_space_or_zero:
        cmp    [edi], byte 0
        je     .found
        cmp    [edi], byte " "
        je     .found
        inc    edi
        jmp    .find_space_or_zero
.found:
        mov    [edi], byte 0
        mov    [file_path], eax
; Check File Path
        mov    eax, [file_path]
        mov    al, [eax]
        test   al, al
        jne    file_path_ok
        mov    [ERROR_MESSAGE], dword err_file_path
        jmp    ERROR
file_path_ok:
; Check MZ Signature
        push   dword [file_path]               ; filepath
        dec    esp
        mov    [esp], byte 0
        push   dword MZ                        ; buffer
        push   dword 2                         ; count
        push   dword 0
        push   dword IMAGE_DOS_HEADER.e_magic  ; position
        push   dword 0
        mov    ebx, esp
        mov    eax, 70
        int    64
        test   eax, eax
        je     read_ok
        mov    [ERROR_MESSAGE], dword err_read_file
        jmp    ERROR
read_ok:
        cmp    word [MZ], "MZ"
        je     MZ_exists
        mov    [ERROR_MESSAGE], dword err_mz_not_found
        jmp    ERROR
MZ_exists:
; Get Offset Of The PE Header
        push   dword [file_path]               ; filepath
        dec    esp
        mov    [esp], byte 0
        push   dword lfa_new                   ; buffer
        push   dword 4                         ; count
        push   dword 0
        push   dword IMAGE_DOS_HEADER.e_lfanew ; position
        push   dword 0
        mov    ebx, esp
        mov    eax, 70
        int    64
; Check PE Signature (IMAGE_NT_HEADERS.Signature)
        push   dword [file_path]               ; filepath
        dec    esp
        mov    [esp], byte 0
        push   dword PE                        ; buffer
        push   dword 2                         ; count
        push   dword 0
        push   dword [lfa_new]                 ; position
        push   dword 0
        mov    ebx, esp
        mov    eax, 70
        int    64
        cmp    word [PE], "PE"
        je     PE_exists
        mov    [ERROR_MESSAGE], dword err_pe_not_found
        jmp    ERROR
PE_exists:
; Get Size Of Headers
        push   dword [file_path]               ; filepath
        dec    esp
        mov    [esp], byte 0
        push   dword SizeOfHeaders             ; buffer
        push   dword 4                         ; count
        push   dword 0
        mov    eax, [lfa_new]
        add    eax, IMAGE_NT_HEADERS.OptionalHeader + IMAGE_OPTIONAL_HEADER.SizeOfHeaders
        push   eax                             ; position
        push   dword 0
        mov    ebx, esp
        mov    eax, 70
        int    64
; Resize App Memory And Load Headers
        mov    eax, IMAGE_BASE
        add    eax, [SizeOfHeaders]
        push   eax
        call   ReallocAppMemory

        push   dword [file_path]               ; filepath
        dec    esp
        mov    [esp], byte 0
        push   dword IMAGE_BASE                ; buffer
        push   dword [SizeOfHeaders]           ; count
        push   dword 0
        push   dword 0                         ; position
        push   dword 0
        mov    ebx, esp
        mov    eax, 70
        int    64

        add    esp, (25 * 5) ; restore our stack top

        mov    edx, [lfa_new]
; Get SizeOfImage
        mov    eax, [IMAGE_BASE + edx + IMAGE_NT_HEADERS.OptionalHeader + IMAGE_OPTIONAL_HEADER.SizeOfImage]
        mov    [SizeOfImage], eax
; Get EntryPoint
        mov    eax, [IMAGE_BASE + edx + IMAGE_NT_HEADERS.OptionalHeader + IMAGE_OPTIONAL_HEADER.AddressOfEntryPoint]
        mov    [EntryPoint], eax
; Get DataDirectories
        lea    eax, [edx + IMAGE_NT_HEADERS.OptionalHeader + IMAGE_OPTIONAL_HEADER.DataDirectory]
        mov    [DataDirectories], eax
; Get SizeOfOptionalHeader
        movzx  eax, word [IMAGE_BASE + edx + IMAGE_NT_HEADERS.FileHeader + IMAGE_FILE_HEADER.SizeOfOptionalHeader]
        mov    [SizeOfOptionalHeader], ax
; Get SectionsTable
        lea    eax, [edx + IMAGE_NT_HEADERS.OptionalHeader]
        add    ax, [SizeOfOptionalHeader]
        mov    [SectionsTable], eax
; Get NumberOfSections
        movzx  eax, word [IMAGE_BASE + edx + IMAGE_NT_HEADERS.FileHeader + IMAGE_FILE_HEADER.NumberOfSections]
        mov    [NumberOfSections], eax
; Resize App Memory And Load Sections To Their Virtual Address
        mov    eax, IMAGE_BASE
        add    eax, [SizeOfImage]
        push   eax
        call   ReallocAppMemory

        mov    ecx, [NumberOfSections]
next_section:
        lea    eax, [ecx - 1]
        lea    eax, [eax * 4 + eax]
        lea    eax, [eax * 8]
        add    eax, IMAGE_BASE
        add    eax, [SectionsTable]

        push   dword [file_path]               ; filepath
        dec    esp
        mov    [esp], byte 0
        mov    edx, [eax + 12]
        add    edx, IMAGE_BASE
        push   edx                             ; buffer(IMAGE_SECTION_HEADER.VirtualAddress)
        push   dword [eax + IMAGE_SECTION_HEADER.SizeOfRawData]    ; count
        push   dword 0
        push   dword [eax + IMAGE_SECTION_HEADER.PointerToRawData] ; position
        push   dword 0
        mov    ebx, esp
        mov    eax, 70
        int    64

        dec    ecx
        jnz    next_section

        mov    eax, [NumberOfSections]
        lea    eax, [eax * 4 + eax]
        lea    eax, [eax * 4 + eax]
        add    esp, eax ; restore our stack top

; SetCurrentDirectory
        mov    edi, [file_path]
        xor    al, al
        xor    ecx, ecx
        dec    ecx
        repne scasb
        std
        mov    al, "/"
        repne scasb
        cld
        mov    [edi + 1], byte 0
        push   dword [file_path]
        call   SetCurrentDirectory
        mov    [edi + 1], byte "/" ; restore full file_path

; Go To EntryPoint
        mov    eax, [EntryPoint]
        add    eax, IMAGE_BASE + MAGIC_OFFSET
        jmp    eax
; ------------------------------------------------------------- ;
ERROR:
        push   sz_console
        call   LoadLibrary
        mov    ecx, eax
        mov    ebx, GetProcAddress
        push   ecx
        push   sz_con_init
        call   ebx
        mov    [con_init], eax
        push   ecx
        push   sz_con_write_asciiz
        call   ebx
        mov    [con_write_asciiz], eax
        push   ecx
        push   sz_con_exit
        call   ebx
        mov    [con_exit], eax

        push   sz_pe_load
        push   -1
        push   -1
        push   -1
        push   -1
        call   [con_init]
        push   dword [ERROR_MESSAGE]
        call   [con_write_asciiz]
        push   0
        call   [con_exit]

        xor    eax, eax
        dec    eax
        int    64
; ------------------------------------------------------------- ;
SECTION .bss
; ------------------------------------------------------------- ;
file_path                      resd   1
; ------------------------------------------------------------- ;
con_init                       resd   1
con_write_asciiz               resd   1
con_exit                       resd   1
console                        resd   1
; ------------------------------------------------------------- ;
ERROR_MESSAGE                  resd   1
; ------------------------------------------------------------- ;
MZ                             resw   1
PE                             resw   1
lfa_new                        resd   1
NumberOfSections               resd   1
SizeOfOptionalHeader           resd   1
EntryPoint                     resd   1
SizeOfImage                    resd   1
SizeOfHeaders                  resd   1
DataDirectories                resd   1
SectionsTable                  resd   1
; ------------------------------------------------------------- ;