Program Project1;
(* -------------------------------------------------------- *)
Type
  Dword = Cardinal;

  SIZE = Record
    Height: Word;
    Width : Word;
  End;
(* -------------------------------------------------------- *)
Const
 (* Window styles *)
  WS_SKINNED_FIXED    =  $4000000;
  WS_SKINNED_SIZABLE  =  $3000000;
  WS_FIXED            =  $0000000;
  WS_SIZABLE          =  $2000000;
  WS_FILL_TRANSPARENT = $40000000;
  WS_FILL_GRADIENT    = $80000000;
  WS_COORD_CLIENT     = $20000000;
  WS_CAPTION          = $10000000;

 (* Caption styles *)
  CAPTION_MOVABLE     = $00000000;
  CAPTION_NONMOVABLE  = $01000000;

 (* Events *)
  REDRAW_EVENT        = 1;
  KEY_EVENT           = 2;
  BUTTON_EVENT        = 3;
  MOUSE_EVENT         = 6;

 (* Size multipliers for DrawText *)
  DT_X1               =  $0000000;
  DT_X2               =  $1000000;
  DT_X3               =  $2000000;
  DT_X4               =  $3000000;
  DT_X5               =  $4000000;
  DT_X6               =  $5000000;
  DT_X7               =  $6000000;
  DT_X8               =  $7000000;

 (* Charset specifiers for DrawText *)
  DT_CP866_6X9        = $00000000;
  DT_CP866_8X16       = $10000000;
  DT_UTF_16LE_8X16    = $20000000;
  DT_UTF_8_8X16       = $30000000;

 (* Fill styles for DrawText *)
  DT_FILL_TRANSPARENT = $00000000;
  DT_FILL_OPAQUE      = $40000000;

 (* Draw zero terminated string for DrawText *)
  DT_ZSTRING          = $80000000;

 (* Colors *)
  COLOR_BLUE          = $000000FF;
  COLOR_RED           = $00FF0000;
  COLOR_GREEN         = $0000FF00;
  COLOR_WHITE         = $00FFFFFF;
  COLOR_BLACK         = $00000000;

  sz_hello  = AnsiString('Hello, Delphi 7.0!');
(* -------------------------------------------------------- *)
Var
  Left, Top, Right, Bottom: Integer;
  Scr: SIZE;
  strRunResult: ShortString;
  strCreateResult: ShortString;
(* -------------------------------------------------------- *)
Procedure Main; Forward;
Procedure BeginDraw; Forward;
Procedure EndDraw; Forward;
Procedure DrawWindow(Left, Top, Right, Bottom: Integer; Caption: PChar; BackColor, Style, CapStyle: Dword); StdCall; Forward;
Procedure DrawText(X, Y: Integer; Text: PChar; ForeColor, BackColor, Flags, Count: Dword); StdCall; Forward;
Procedure DrawStr(X, Y: Integer; Text: PChar; ForeColor, BackColor, Flags: Dword); Forward; Overload;
Procedure DrawStr(X, Y: Integer; Text: ShortString; ForeColor, BackColor, Flags: Dword); Forward; Overload;
Function  ReadFile(Path: PChar; Buffer: Pointer; Count, LoPos, HiPos: Dword): Integer; StdCall; Forward;
Function  CreateFile(Path: PChar): Integer; StdCall; Forward;
Function  RunFile(Path, Params: PChar): Integer; StdCall; Forward;
Procedure ThreadTerminate; Forward;
Procedure On_Redraw; Forward;
Procedure On_Key; Forward;
Procedure On_Button; Forward;
Function  WaitEvent: Dword; Forward;
Function  GetKey: Dword; Forward;
Function  GetButton: Dword; Forward;
Function  GetScreenSize: SIZE; Forward;
(* -------------------------------------------------------- *)
Procedure Main();
Begin
  Scr := GetScreenSize();

  Right  := Scr.Width  Shr 2;
  Bottom := Scr.Height Shr 2;
  Left   := (Scr.Width  - Right)  Shr 1;
  Top    := (Scr.Height - Bottom) Shr 1;

  If CreateFile('/sys/NewFile.txt') = 0 Then
    strCreateResult := 'File created.'
  Else
    strCreateResult := 'CreateFile Error!';

  If RunFile('/sys/develop/cobj', '/sys/lib/box_lib.obj') > 0 Then
    strRunResult := 'Program started successfully.'
  Else
    strRunResult := 'RunFile Error!';

  While TRUE Do Begin
    Case WaitEvent() Of
    REDRAW_EVENT : On_Redraw;
    KEY_EVENT    : On_Key;
    BUTTON_EVENT : On_Button;
    End;
  End;
End;
(* -------------------------------------------------------- *)
Procedure On_Redraw();
Var S1, S2, S3: ShortString;
    Buffer: Array[1..64] Of Char;
Begin
 BeginDraw;
 DrawWindow(Left, Top, Right, Bottom, sz_hello, COLOR_WHITE, WS_SKINNED_FIXED + WS_COORD_CLIENT + WS_CAPTION, CAPTION_MOVABLE);

 S1 := '1234567890';
 S2 := '0987654321';
 S3 := 'qwertyuiop';

 DrawStr(20, 30, S1, COLOR_RED, COLOR_GREEN, DT_CP866_6X9);
 DrawStr(20, 40, S2, COLOR_RED, COLOR_GREEN, DT_CP866_6X9);
 DrawStr(20, 50, S3, COLOR_RED, COLOR_GREEN, DT_CP866_6X9);

 S1 := S3;
 S3 := S2;

 DrawStr(20, 60, S1, COLOR_RED, COLOR_GREEN, DT_CP866_6X9);
 DrawStr(20, 70, S2, COLOR_RED, COLOR_GREEN, DT_CP866_6X9);
 DrawStr(20, 80, S3, COLOR_RED, COLOR_GREEN, DT_CP866_6X9);

 If S2 = S3 Then Begin
   DrawStr(20, 90, 'S2 = S3', COLOR_RED, COLOR_GREEN, DT_CP866_6X9);
 End;

 If S1 <> S2 Then Begin
   DrawStr(20, 100, 'S1 <> S2', COLOR_RED, COLOR_GREEN, DT_CP866_6X9);
 End;

 If ReadFile('/sys/file managers/KFM_KEYS.TXT', @Buffer, 60, 0, 0) = 0 Then
    DrawStr(20, 110, @Buffer, COLOR_RED, COLOR_GREEN, DT_CP866_8X16)
 Else
    DrawStr(20, 110, 'ReadFile Error!', COLOR_RED, COLOR_GREEN, DT_CP866_8X16);

 DrawStr(20, 127, strCreateResult, COLOR_RED, COLOR_GREEN, DT_CP866_8X16);
 DrawStr(20, 144, strRunResult, COLOR_RED, COLOR_GREEN, DT_CP866_8X16);

 EndDraw;
End;
(* -------------------------------------------------------- *)
Procedure On_Key();
Begin
  GetKey;
End;
(* -------------------------------------------------------- *)
Procedure On_Button();
Begin
  Case GetButton() Shr 8 Of
  1 : ThreadTerminate;
  End;
End;
(* -------------------------------------------------------- *)
Procedure DrawStr(X, Y: Integer; Text: PChar; ForeColor, BackColor, Flags: Dword); Overload;
Begin
  DrawText(X, Y, Text, ForeColor, BackColor, Flags Or DT_ZSTRING, 0);
End;
(* -------------------------------------------------------- *)
Procedure DrawStr(X, Y: Integer; Text: ShortString; ForeColor, BackColor, Flags: Dword); Overload;
Begin
  DrawText(X, Y, @Text[1], ForeColor, BackColor, Flags And Not DT_ZSTRING, Dword(Text[0]));
End;
(* -------------------------------------------------------- *)
Procedure BeginDraw();
Asm
        push   ebx
        mov    eax, 12
        mov    ebx, 1
        int    64
        pop    ebx
End;
(* -------------------------------------------------------- *)
Procedure EndDraw();
Asm
        push   ebx
        mov    eax, 12
        mov    ebx, 2
        int    64
        pop    ebx
End;
(* -------------------------------------------------------- *)
Procedure DrawWindow(Left, Top, Right, Bottom: Integer; Caption: PChar; BackColor, Style, CapStyle: Dword);
Asm
        push   ebx
        push   edi
        push   esi
        xor    eax, eax
        mov    ebx, Left
        shl    ebx, 16
        add    ebx, Right
        mov    ecx, Top
        shl    ecx, 16
        add    ecx, Bottom
        mov    edx, Style
        or     edx, BackColor
        mov    edi, Caption
        mov    esi, CapStyle
        int    64
        pop    esi
        pop    edi
        pop    ebx
End;
(* -------------------------------------------------------- *)
Function WaitEvent(): Dword;
Asm
        mov    eax, 10
        int    64
End;
(* -------------------------------------------------------- *)
Function GetKey(): Dword;
Asm
        mov    eax, 2
        int    64
End;
(* -------------------------------------------------------- *)
Function GetButton(): Dword;
Asm
        mov    eax, 17
        int    64
End;
(* -------------------------------------------------------- *)
Procedure ThreadTerminate();
Asm
        mov    eax, $FFFFFFFF;
        int    64
End;
(* -------------------------------------------------------- *)
Function GetScreenSize(): SIZE;
Asm
        push   ebx
        mov    eax, 61
        mov    ebx, 1
        int    64
        pop    ebx
End;
(* -------------------------------------------------------- *)
Procedure DrawText(X, Y: Integer; Text: PChar; ForeColor, BackColor, Flags, Count: Dword);
Asm
        push   ebx
        push   edi
        push   esi
        mov    eax, 4
        mov    ebx, X
        shl    ebx, 16
        add    ebx, Y
        mov    ecx, Flags
        or     ecx, ForeColor
        mov    edx, Text
        mov    edi, BackColor
        mov    esi, Count
        int    64
        pop    esi
        pop    edi
        pop    ebx
End;
(* -------------------------------------------------------- *)
Function ReadFile(Path: PChar; Buffer: Pointer; Count, LoPos, HiPos: Dword): Integer;
Asm
        push   ebx
        push   Path
        dec    esp
        mov    byte[esp], 0
        push   Buffer
        push   Count
        push   HiPos
        push   LoPos
        push   0
        mov    ebx, esp
        mov    eax, 70
        int    64
        add    esp, 25
        pop    ebx
End;
(* -------------------------------------------------------- *)
Function CreateFile(Path: PChar): Integer;
Asm
        push   ebx
        push   Path
        dec    esp
        mov    byte[esp], 0
        push   0
        push   0
        push   0
        push   0
        push   2
        mov    ebx, esp
        mov    eax, 70
        int    64
        add    esp, 25
        pop    ebx
End;
(* -------------------------------------------------------- *)
Function RunFile(Path, Params: PChar): Integer;
Asm
        push   ebx
        push   Path
        dec    esp
        mov    byte[esp], 0
        push   0
        push   0
        push   Params
        push   0
        push   7
        mov    ebx, esp
        mov    eax, 70
        int    64
        add    esp, 25
        pop    ebx
End;
(* -------------------------------------------------------- *)
Begin Main; end.
