Program Project1;
(* -------------------------------------------------------- *)
Type
  Dword = Cardinal;

  SIZE = Record
    Height: Word;
    Width : Word;
  End;

  SCROLLBAR = Packed Record
    size_x     : Word;
    start_x    : Smallint;
    size_y     : Word;
    start_y    : Smallint;
    btn_high   : Cardinal;
    mode       : Cardinal;
    max_area   : Cardinal;
    cur_area   : Cardinal;
    position   : Cardinal;
    bckg_col   : Cardinal;
    frnt_col   : Cardinal;
    line_col   : Cardinal;
    redraw     : Cardinal;
    delta      : Smallint;
    delta2     : Smallint;
    r_size_x   : Word;
    r_start_x  : Smallint;
    r_size_y   : Word;
    r_start_y  : Smallint;
    m_pos      : Cardinal;
    m_pos_2    : Cardinal;
    m_keys     : Cardinal;
    run_size   : Cardinal;
    position2  : Cardinal;
    work_size  : Cardinal;
    all_redraw : Cardinal;
    ar_offset  : Cardinal;
   End;

   PSCROLLBAR = ^SCROLLBAR;

(* -------------------------------------------------------- *)
Const
 (* Window styles *)
  WS_SKINNED_FIXED    =  $4000000;
  WS_SKINNED_SIZABLE  =  $3000000;
  WS_FIXED            =  $0000000;
  WS_SIZABLE          =  $2000000;
  WS_FILL_TRANSPARENT = $40000000;
  WS_FILL_GRADIENT    = $80000000;
  WS_COORD_CLIENT     = $20000000;
  WS_CAPTION          = $10000000;

 (* Caption styles *)
  CAPTION_MOVABLE     = $00000000;
  CAPTION_NONMOVABLE  = $01000000;

 (* Events *)
  REDRAW_EVENT        = 1;
  KEY_EVENT           = 2;
  BUTTON_EVENT        = 3;
  MOUSE_EVENT         = 6;

 (* Event Mask Constants *)
  EM_REDRAW           = $01;
  EM_KEY              = $02;
  EM_BUTTON           = $04;
  EM_MOUSE            = $20;

 (* Size multipliers for DrawText *)
  DT_X1               =  $0000000;
  DT_X2               =  $1000000;
  DT_X3               =  $2000000;
  DT_X4               =  $3000000;
  DT_X5               =  $4000000;
  DT_X6               =  $5000000;
  DT_X7               =  $6000000;
  DT_X8               =  $7000000;

 (* Charset specifiers for DrawText *)
  DT_CP866_6X9        = $00000000;
  DT_CP866_8X16       = $10000000;
  DT_UTF_16LE_8X16    = $20000000;
  DT_UTF_8_8X16       = $30000000;

 (* Fill styles for DrawText *)
  DT_FILL_TRANSPARENT = $00000000;
  DT_FILL_OPAQUE      = $40000000;

 (* Draw zero terminated string for DrawText *)
  DT_ZSTRING          = $80000000;

 (* Button styles *)
  BS_FILL_TRANSPARENT = $40000000;
  BS_NO_FRAME         = $20000000;

 (* Colors *)
  COLOR_BLUE          = $000000FF;
  COLOR_RED           = $00FF0000;
  COLOR_GREEN         = $0000FF00;
  COLOR_WHITE         = $00FFFFFF;
  COLOR_BLACK         = $00000000;

 (* Buttons *)
  BLUE_BUTTON        = 100;
  GREEN_BUTTON       = 200;
  RED_BUTTON         = 300;
  BLACK_BUTTON       = 400;

  sz_hello  = AnsiString('Hello, Delphi 7.0!');
(* -------------------------------------------------------- *)
Var
  Left, Top, Right, Bottom: Integer;
  Scr: SIZE;
  hBoxLib: Pointer;
  HScrollbarDraw  : Procedure(Scrollbar: PSCROLLBAR); StdCall;
  HScrollbarMouse : Procedure(Scrollbar: PSCROLLBAR); StdCall;
  Scrollbar1: SCROLLBAR;
(* -------------------------------------------------------- *)
Procedure Main; Forward;
Procedure BeginDraw; Forward;
Procedure EndDraw; Forward;
Procedure DrawWindow(Left, Top, Right, Bottom: Integer; Caption: PChar; BackColor, Style, CapStyle: Dword); StdCall; Forward;
Procedure DrawText(X, Y: Integer; Text: PChar; ForeColor, BackColor, Flags, Count: Dword); StdCall; Forward;
Procedure DrawStr(X, Y: Integer; Text: PChar; ForeColor, BackColor, Flags: Dword); Forward; Overload;
Procedure DrawStr(X, Y: Integer; Text: ShortString; ForeColor, BackColor, Flags: Dword); Forward; Overload;
Function  ReadFile(Path: PChar; Buffer: Pointer; Count, LoPos, HiPos: Dword): Integer; StdCall; Forward;
Function  CreateFile(Path: PChar): Integer; StdCall; Forward;
Function  RunFile(Path, Params: PChar): Integer; StdCall; Forward;
Procedure DrawButton(Left, Top, Right, Bottom: Integer; BackColor, Style, ID: Dword); StdCall; Forward;
Procedure DeleteButton(ID: Dword); StdCall; Forward;
Procedure SetWindowCaption(Caption: PChar); StdCall; Forward;
Function  LoadLibrary(Path: PChar): Pointer; StdCall; Forward;
Function  GetProcAddress(hLib: Pointer; ProcName: PChar): Pointer; StdCall; Forward;
Function  SetEventMask(Mask: Dword): Dword; StdCall; Forward;
Procedure ThreadTerminate; Forward;
Procedure On_Redraw; Forward;
Procedure On_Key; Forward;
Procedure On_Button; Forward;
Procedure On_Mouse; Forward;
Function  WaitEvent: Dword; Forward;
Function  GetKey: Dword; Forward;
Function  GetButton: Dword; Forward;
Function  GetScreenSize: SIZE; Forward;
(* -------------------------------------------------------- *)
Procedure Main();
Begin
  Scr := GetScreenSize();

  Right  := Scr.Width  Shr 2;
  Bottom := Scr.Height Shr 2;
  Left   := (Scr.Width  - Right)  Shr 1;
  Top    := (Scr.Height - Bottom) Shr 1;

  hBoxLib := LoadLibrary('/sys/lib/box_lib.obj');
  HScrollbarDraw  := GetProcAddress(hBoxLib, 'scrollbar_h_draw');
  HScrollbarMouse := GetProcAddress(hBoxLib, 'scrollbar_h_mouse');

  With Scrollbar1 Do Begin
    ar_offset  := 1;
    all_redraw := 1;
    size_x     := 200;
    btn_high   := 16;
    bckg_col   := COLOR_GREEN;
    frnt_col   := COLOR_GREEN Or COLOR_BLUE;
    line_col   := COLOR_BLUE;
    start_y    := 40;
    size_y     := 16;
    start_x    := 35;
    max_area   := 160;
    cur_area   := 40;
    mode       := 1;
  End;

  SetEventMask(EM_REDRAW + EM_KEY + EM_BUTTON + EM_MOUSE);

  While TRUE Do Begin
    Case WaitEvent() Of
    REDRAW_EVENT : On_Redraw;
    KEY_EVENT    : On_Key;
    BUTTON_EVENT : On_Button;
    MOUSE_EVENT  : On_Mouse;
    End;
  End;
End;
(* -------------------------------------------------------- *)
Procedure On_Redraw();
Begin
 BeginDraw;
 DrawWindow(Left, Top, Right, Bottom, sz_hello, COLOR_WHITE, WS_SKINNED_FIXED + WS_COORD_CLIENT + WS_CAPTION, CAPTION_MOVABLE);
 Scrollbar1.all_redraw := 1;
 HScrollbarDraw(@Scrollbar1);
 EndDraw;
End;
(* -------------------------------------------------------- *)
Procedure On_Key();
Begin
  GetKey;
End;
(* -------------------------------------------------------- *)
Procedure On_Button();
Begin
  Case GetButton() Shr 8 Of
  1: ThreadTerminate;
  End;
End;
(* -------------------------------------------------------- *)
Procedure On_Mouse();
Begin
  HScrollbarMouse(@Scrollbar1);;
End;
(* -------------------------------------------------------- *)
Procedure DrawStr(X, Y: Integer; Text: PChar; ForeColor, BackColor, Flags: Dword); Overload;
Begin
  DrawText(X, Y, Text, ForeColor, BackColor, Flags Or DT_ZSTRING, 0);
End;
(* -------------------------------------------------------- *)
Procedure DrawStr(X, Y: Integer; Text: ShortString; ForeColor, BackColor, Flags: Dword); Overload;
Begin
  DrawText(X, Y, @Text[1], ForeColor, BackColor, Flags And Not DT_ZSTRING, Dword(Text[0]));
End;
(* -------------------------------------------------------- *)
Function GetProcAddress(hLib: Pointer; ProcName: PChar): Pointer;
Asm
        push   esi
        push   edi
        push   ebx
        mov    edx, hLib
        xor    eax, eax
        test   edx, edx
        jz     @end
        mov    edi, ProcName
        mov    ecx, $FFFFFFFF
        repne scasb
        mov    ebx, ecx
        not    ebx
@next:
        mov    esi, [edx]
        test   esi, esi
        jz     @end
        mov    ecx, ebx
        mov    edi, ProcName
        add    edx, 8
        repe cmpsb
        jne    @next
        mov    eax, [edx - 4]
@end:
        pop    ebx
        pop    edi
        pop    esi
End;
(* -------------------------------------------------------- *)
Procedure BeginDraw();
Asm
        push   ebx
        mov    eax, 12
        mov    ebx, 1
        int    64
        pop    ebx
End;
(* -------------------------------------------------------- *)
Procedure EndDraw();
Asm
        push   ebx
        mov    eax, 12
        mov    ebx, 2
        int    64
        pop    ebx
End;
(* -------------------------------------------------------- *)
Procedure DrawWindow(Left, Top, Right, Bottom: Integer; Caption: PChar; BackColor, Style, CapStyle: Dword);
Asm
        push   ebx
        push   edi
        push   esi
        xor    eax, eax
        mov    ebx, Left
        shl    ebx, 16
        add    ebx, Right
        mov    ecx, Top
        shl    ecx, 16
        add    ecx, Bottom
        mov    edx, Style
        or     edx, BackColor
        mov    edi, Caption
        mov    esi, CapStyle
        int    64
        pop    esi
        pop    edi
        pop    ebx
End;
(* -------------------------------------------------------- *)
Function WaitEvent(): Dword;
Asm
        mov    eax, 10
        int    64
End;
(* -------------------------------------------------------- *)
Function GetKey(): Dword;
Asm
        mov    eax, 2
        int    64
End;
(* -------------------------------------------------------- *)
Function GetButton(): Dword;
Asm
        mov    eax, 17
        int    64
End;
(* -------------------------------------------------------- *)
Procedure ThreadTerminate();
Asm
        mov    eax, $FFFFFFFF;
        int    64
End;
(* -------------------------------------------------------- *)
Function GetScreenSize(): SIZE;
Asm
        push   ebx
        mov    eax, 61
        mov    ebx, 1
        int    64
        pop    ebx
End;
(* -------------------------------------------------------- *)
Procedure DrawText(X, Y: Integer; Text: PChar; ForeColor, BackColor, Flags, Count: Dword);
Asm
        push   ebx
        push   edi
        push   esi
        mov    eax, 4
        mov    ebx, X
        shl    ebx, 16
        add    ebx, Y
        mov    ecx, Flags
        or     ecx, ForeColor
        mov    edx, Text
        mov    edi, BackColor
        mov    esi, Count
        int    64
        pop    esi
        pop    edi
        pop    ebx
End;
(* -------------------------------------------------------- *)
Function ReadFile(Path: PChar; Buffer: Pointer; Count, LoPos, HiPos: Dword): Integer;
Asm
        push   ebx
        push   Path
        dec    esp
        mov    byte[esp], 0
        push   Buffer
        push   Count
        push   HiPos
        push   LoPos
        push   0
        mov    ebx, esp
        mov    eax, 70
        int    64
        add    esp, 25
        pop    ebx
End;
(* -------------------------------------------------------- *)
Function CreateFile(Path: PChar): Integer;
Asm
        push   ebx
        push   Path
        dec    esp
        mov    byte[esp], 0
        push   0
        push   0
        push   0
        push   0
        push   2
        mov    ebx, esp
        mov    eax, 70
        int    64
        add    esp, 25
        pop    ebx
End;
(* -------------------------------------------------------- *)
Function RunFile(Path, Params: PChar): Integer;
Asm
        push   ebx
        push   Path
        dec    esp
        mov    byte[esp], 0
        push   0
        push   0
        push   Params
        push   0
        push   7
        mov    ebx, esp
        mov    eax, 70
        int    64
        add    esp, 25
        pop    ebx
End;
(* -------------------------------------------------------- *)
Procedure DrawButton(Left, Top, Right, Bottom: Integer; BackColor, Style, ID: Dword);
Asm
        push   ebx
        push   esi
        mov    eax, 8
        mov    ebx, Left
        mov    ecx, Top
        shl    ebx, 16
        shl    ecx, 16
        add    ebx, Right
        add    ecx, Bottom
        mov    edx, ID
        or     edx, Style
        mov    esi, BackColor
        int    64
        pop    esi
        pop    ebx
End;
(* -------------------------------------------------------- *)
Procedure DeleteButton(ID: Dword);
Asm
        mov    eax, 8
        mov    edx, ID
        or     edx, $80000000
        int    64
End;
(* -------------------------------------------------------- *)
Procedure SetWindowCaption(Caption: PChar);
Asm
        push   ebx
        mov    eax, 71
        mov    ebx, 1
        mov    ecx, Caption
        int    64
        pop    ebx
End;
(* -------------------------------------------------------- *)
Function LoadLibrary(Path: PChar): Pointer;
Asm
        push   ebx
        mov    eax, 68
        mov    ebx, 19
        mov    ecx, Path
        int    64
        pop    ebx
End;
(* -------------------------------------------------------- *)
Function SetEventMask(Mask: Dword): Dword;
Asm
        push   ebx
        mov    eax, 40
        mov    ebx, Mask
        int    64
        pop    ebx
End;
(* -------------------------------------------------------- *)
Begin Main; end.
